<!-- manual page source format generated by PolyglotMan v3.0.7, -->
<!-- available via anonymous ftp from ftp.cs.berkeley.edu:/ucb/people/phelps/tcltk/rman.tar.Z -->

<HTML>
<HEAD>
<TITLE>Man page for skweel.1</TITLE>
</HEAD>
<BODY bgcolor=white>
<A HREF="#toc">Table of Contents</A><P>

<H2><A NAME="sect0" HREF="#toc0">Name</A></H2>

<P>
skweel - optimize loop-level parallelism and locality

<H2><A NAME="sect1" HREF="#toc1"><B>Synopsis</B></A></H2>

<P>
<B>skweel</B> [ <I>options</I> ] <I>infile</I> <I>outfile</I>

<H2><A NAME="sect2" HREF="#toc2"><B>Description</B></A></H2>

<P>
The <I>skweel</I> program analyzes and transforms the code to
optimize loop-level parallelism and locality.
<P>
The transformations <I>skweel</I> performs includes a general
class of loop transformations known as unimodular transformations".
These transformations include loop interchange,
loop skewing and loop reversal. <I>Skweel</I> can also
tile loop nests for cache locality.
<P>
This pass expects two file specifications on the command
line, first for the input file, then for the output file.
When <I>scc</I> is run with the <I>-parallel</I> or <I>-multi</I> flags, <I>skweel</I>
will be run. In both cases, <I>skweel</I> is called with the
options <I>-P</I> <I>-T</I> <I>-i.</I>

<H2><A NAME="sect3" HREF="#toc3"><B>Options:</B></A></H2>

<P>
<B>-A</B> <I>n</I> Print out the SUIF code before and/or after transformation.
If the integer <I>n</I> is set to 1, the SUIF
code is printed before transformation. If it is set
to 2, then the code is printed after transformation.
The code is printed both before and after
transformation if <I>n</I> is set to 3.

<DL>

<DT><B>-N</B> </DT></DT>
<DD>    Normalize the loops only; do not transform to
improve code.
</DD>

<DT><B>-P</B> <I>n</I> </DT></DT>
<DD>Parallelism level. Look for parallelism and annotate
the parallel loops in the code. The default
is 1.
</DD>

<DT><B>-Q</B> <I>n</I> </DT></DT>
<DD>Process up to <I>n</I> functions before quitting. The
default is 100,000.
</DD>

<DT><B>-S</B> </DT></DT>
<DD>    Do not perform scalar privatization.
</DD>

<DT><B>-T</B> </DT></DT>
<DD>    Do not tile the code.
</DD>

<DT><B>-V</B> </DT></DT>
<DD>    Turn on verbose mode. This prints information
about the function being processed, the dependences
found, etc.
</DD>

<DT><B>-W</B> </DT></DT>
<DD>    Print statistics about the input program including
loop nest shape and loop nest depth.
</DD>

<DT><B>-2</B> </DT></DT>
<DD>    When tiling a loop nest of depth n, coalesce the
tile to generate 2n-1 loops rather than 2n.
</DD>

<DT><B>-c</B> <I>n</I> </DT></DT>
<DD>Set the cache size to the integer <I>n</I> bytes. This
value is used to calculate block sizes when tiling.
The default is 65536 (64K).
</DD>

<DT><B>-f</B> <I>g</I> </DT></DT>
<DD>Set the fraction of the cache to fill to the floating-point
value <I>g.</I> This value is used to calculate
block sizes when tiling. The default is 0.6.
</DD>

<DT><B>-i</B> </DT></DT>
<DD>    Interchange loops for register locality.
</DD>

<DT><B>-l</B> <I>n</I> </DT></DT>
<DD>Set the cache line size to the integer <I>n</I> bytes.
This value is used to calculate block sizes when
tiling.
</DD>

<DT><B>-p</B> </DT></DT>
<DD>    Print a summary of the for loops in the program.
The summary includes information about which loops
can and cannot be transformed.
</DD>

<DT><B>-y</B> <I>n</I> </DT></DT>
<DD>Do not parallelize loops with less than <I>n.</I> iterations.
The default is set to 0, meaning that all
parallel loops found will be marked with doall"
annotations.
</DD>

<DT><B>-z</B> <I>n</I> </DT></DT>
<DD>Do not parallelize loops with less work than the
integer <I>n.</I> The amount of work in a loop is estimated
by a function of the loop bounds and the number
of instructions in the loop. The work estimation
function used by <I>skweel</I> is from the <I>useful</I>
library. The default is set to 0, meaning that all
parallel loops found will be marked with doall"
annotations.
</DD>
</DL>

<H2><A NAME="sect4" HREF="#toc4"><B>Annotations</B> <B>Read</B></A></H2>

<P>
<B>privatizable</B> <I>var</I><B>*</B><BR>

This annotation is placed on TREE_FOR nodes by the
scalar expansion pass of <I>moo</I> and <I>oynk.</I> Private
copies of the var_syms <I>var</I> can be made for each
iteration of the loop nest. This information is
used to parallelize loops.
<P>
<B>need_finalization</B> <I>var</I><B>*</B><BR>

This annotation is placed on TREE_FOR nodes by the
scalar expansion pass of <I>oynk.</I> Finalization is
needed in order for the var_syms <I>var</I> to privatized.
Currently, <I>skweel</I> will not privatize any variables
that need finalization.
<P>
<B>iv_live</B><BR>

This annotation is placed on TREE_FOR nodes by the
scalar expansion pass of <I>oynk.</I> The induction variable
for this loop is read after exiting the loop.
If a loop has a live induction variable, <I>skweel</I>
will not consider transforming the loop.
<P>
<B>pure</B> <B>function</B><BR>

This annotation is placed on the proc_sym for FORTRAN
intrinsic functions that are known to have no
side-effects. <I>Skweel</I> will not parallelize loops
that contain calls to functions that do not have
pure function annotations.
<P>
<B>reduction</B> <I>type</I> <I>var</I><BR>

This annotation is placed on TREE_FOR nodes and
instructions by reduction. A reduction of the commutative
operation <I>type</I> is calculated over the
var_sym <I>var.</I> Currently supported reduction types
include sum, product, max and min.
<P>
<B>C</B> <B>pragma</B> <B>doall</B><BR>

<B>doall</B> These annotations are generated by the front-end
from pragmas in the source code. They allow users
to explicitly parallelize loops that <I>skweel</I>
wouldn't otherwise parallelize. The annotations
are placed on mrk instructions. When <I>skweel</I> sees
one of these annotations, it puts a doall annotation
on the closest TREE_FOR following the mrk
instruction. The TREE_FOR must be in the same list
as the mrk instruction. Subsequent passes (e.g.
<I>pgen</I> ) will now treat the loop as parallel.

<H2><A NAME="sect5" HREF="#toc5"><B>Annotations</B> <B>Written</B></A></H2>

<P>
<B>begin_fully_permutable</B><BR>

<B>end_fully_permutable</B><BR>

These annotations are placed on TREE_FOR nodes to
mark the boundaries of fully permutable loop nests.
If a loop nest is fully permutable then any permutation
of the loops within the nest is legal, and
the loop nest can be tiled.
<P>
<B>doall</B> This annotation is placed on TREE_FOR nodes that
<P>
<I>skweel</I> determines can be legally run in parallel.
The doall annotation is read by <I>pgen.</I>
<P>
<B>privatized</B> <I>vars</I><B>+</B><BR>

This annotation is placed on TREE_FOR nodes, and is
used in conjunction with the doall annotation.
The var_syms <I>var</I> must be made private in order for
the code to run correctly in parallel. The privatized"
annotation is read by <I>pgen.</I>
<P>
<B>reduced</B> <I>type</I> <I>var</I><BR>

This annotation is placed on TREE_FOR nodes, and is
used in conjunction with the doall annotation. A
reduction of the commutative operation <I>type</I> must be
calculated over the var_sym <I>var</I> in order for the
code to run correctly in parallel. The reduced"
annotation is read by <I>pgen.</I>
<P>
<B>small_bound</B><BR>

This annotation is placed on TREE_FOR nodes. The
loop was not marked with a doall annotation
because the number of iterations in the loop was
deemed too small (using the parameter specified
with the <I>-y</I> flag.

<H2><A NAME="sect6" HREF="#toc6"><B>See</B> <B>Also</B></A></H2>

<P>
<A HREF="man_fixfortran.1.html">fixfortran(1)</A>
, <A HREF="man_oynk.1.html">oynk(1)</A>
, <A HREF="man_moo.1.html">moo(1)</A>
, <A HREF="man_pgen.1.html">pgen(1)</A>
, <A HREF="man_reduction.1.html">reduction(1)</A>
,
<A HREF="man_scc.1.html">scc(1)</A>

<P>
<B>Michael</B> <B>E.</B> <B>Wolf.</B> Improving Locality and Parallelism in
Nested Loops", Ph.D. thesis, Stanford University, Computer
Systems Laboratory, August, 1992.
<P>
<B>M.</B> <B>E.</B> <B>Wolf</B> <B>and</B> <B>M.</B> <B>S.</B> <B>Lam.</B> A Loop Transformation Theory
and An Algorithm to Maximize Parallelism", <I>IEEE</I> <I>Transac</I><B>_</B>t<I>ions</I>
<I>on</I> <I>Parallel</I> <I>and</I> <I>Distributed</I> <I>Systems,</I> October, 1991.
<P>
<B>M.</B> <B>E.</B> <B>Wolf</B> <B>and</B> <B>M.</B> <B>S.</B> <B>Lam.</B> A Data Locality Optimizing
Algorithm", <I>Proceedings</I> <I>of</I> <I>the</I> <I>ACM</I> <I>SIGPLAN'91</I> <I>Conference</I>
<I>on</I> <I>Programming</I> <I>Language</I> <I>Design</I> <I>and</I> <I>Implementation,</I> June,
1991.

<H2><A NAME="sect7" HREF="#toc7"><B>History</B></A></H2>

<P>
The original parallelism and locality optimizer for the
old SUIF system was written by Michael Wolf. Jennifer
Anderson translated it to new SUIF, and added some features.
<P>

<HR><P>
<A NAME="toc"><B>Table of Contents</B></A><P>
<UL>
<LI><A NAME="toc0" HREF="#sect0">Name</A></LI>
<LI><A NAME="toc1" HREF="#sect1">Synopsis</A></LI>
<LI><A NAME="toc2" HREF="#sect2">Description</A></LI>
<LI><A NAME="toc3" HREF="#sect3">Options:</A></LI>
<LI><A NAME="toc4" HREF="#sect4">Annotations Read</A></LI>
<LI><A NAME="toc5" HREF="#sect5">Annotations Written</A></LI>
<LI><A NAME="toc6" HREF="#sect6">See Also</A></LI>
<LI><A NAME="toc7" HREF="#sect7">History</A></LI>
</UL>
</BODY></HTML>
